﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.8
@EndOfDesignText@
'zDatePicker CustomView class.
'Version 1.0
'Author: yshzsl

'Event declarations
#Event: ValueChanged(Date as String)
#RaisesSynchronousEvents:ValueChanged

'Designer property declarations
#DesignerProperty: Key: DateFormat, DisplayName: DateFormat, FieldType: String, DefaultValue: MM/dd/yyyy, List: yyyy年MM月dd日|yyyy-MM-dd|yyyy.MM.dd|yyyy/MM/dd|MM/dd/yyyy|MM-dd-yyyy ,Description:date format
#DesignerProperty: Key: Language, DisplayName: Language, FieldType: string, DefaultValue: English,List:English|Chinese ,Description:Language used in the date panel
#DesignerProperty: Key: FirstdayofWeek, DisplayName:FirstdayofWeek, FieldType: string, DefaultValue: Sunday,List:Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday ,Description:The first day of week
#DesignerProperty: Key: PickerPanelWidth, DisplayName: PickerPanelWidth, FieldType: int, DefaultValue: 175,Description:Width of the Picker panel
#DesignerProperty: Key: PickerPanelHeight, DisplayName: PickerPanelHeight, FieldType: int, DefaultValue: 175,Description:Height of the Picker panel
#DesignerProperty: Key: BodyBackground, DisplayName: BodyBackground, FieldType: color, DefaultValue: 0xFFFFFFFF,Description:Body background color of the Picker panel
#DesignerProperty: Key: BodyTextColor, DisplayName: BodyTextColor, FieldType: Color, DefaultValue: 0xFF000000, Description:Body Text color of the Picker panel
#DesignerProperty: Key: HeaderBackground, DisplayName: HeaderBackground, FieldType: Color, DefaultValue: 0xFF87CEFA, Description:Header background color of the Picker panel
#DesignerProperty: Key: HeaderTextColor, DisplayName: HeaderTextColor, FieldType: Color, DefaultValue: 0xFF000000, Description:Header text color of the Picker panel
#DesignerProperty: Key: WeekTextBackground, DisplayName: WeekTextBackground, FieldType: color, DefaultValue: 0xFFFDF5E6,Description:WeekText background color of the Picker panel
#DesignerProperty: Key: WeekTextColor, DisplayName: WeekTextColor, FieldType: Color, DefaultValue: 0xFFFF00FF, Description:WeekText color of the datePicker panel
#DesignerProperty: Key: SelectedDateBackground, DisplayName:SelectedDateBackground, FieldType: Color, DefaultValue: 0xFFADD8E6, Description:background color of the Selected date in Picker panel
#DesignerProperty: Key: SelectedDateTextColor, DisplayName: SelectedDateTextColor, FieldType: Color, DefaultValue: 0xFF000000, Description:Text color of the Selected date in Picker panel
#DesignerProperty: Key: ShowGridLines, DisplayName: ShowGridLines, FieldType: boolean, DefaultValue: True,List:True|False, Description:Whether grid lines are shown

'定义属性及布局部分 ***********************************************************************************
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	Private mYear,mMonth,mDay As Int
	Private mWeekNames(7),mMonthNames(12),mDateFormat,mLanguage,mFirstdayofWeek,Alignment(2),mText As String
	Private mTextColor,mBackgroundColor,mBorderColor,myBorderColor,mBorderSize,mBorderRadius,mAlignment As Int
	Private mPickerPanelWidth,mPickerPanelHeight,mBodyBackground,mBodyTextColor,mHeaderBackground,mHeaderTextColor,mWeekTextBackground,mWeekTextColor,mSelectedDateBackground,mSelectedDateTextColor As Int
	Private mLeft, mTop, mWidth, mHeight,mTextSize,z As Double
	Private ImageView1,lImg1,lImg2,rImg1,rImg2 As ImageView
	Private Label1,MonthLabel,YearLabel As Label
	Private Panel1,Panel2,Panel3,Panel4, HeaderPanel,TouchPanel,lPanel,rPanel,lImg1Panel,lImg2Panel,rImg1Panel,rImg2Panel As Panel	
	Private Table1 As Table	
	Private mFont As Typeface
	Private mBase,mParent As B4XView
	Private cvsBase As B4XCanvas
	Private rectBase As B4XRect
	Private gmap,gmap1 As Map
	Private mVisible,mEnabled,mShowGridLines As Boolean
	Private mWeekdayOrder(7),mElevation As Int
	Private mRc As RowCol	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	mDateFormat="MM/dd/yyyy"
	mLanguage="English"
	mFirstdayofWeek="Sunday"
	mPickerPanelWidth=190dip
	mPickerPanelHeight=200dip	
	Alignment(0)="CENTER"
	Alignment(1)="LEFT"
	mEnabled=True
	mVisible=True
	mElevation=1000dip
	mBodyBackground=0xFFFFFFFF
	mBodyTextColor=0xFF000000
	mHeaderBackground=0xFF87CEFA
	mHeaderTextColor=0xFF000000
	mWeekTextBackground=0xFFFDF5E6
	mWeekTextColor=0xFFFF00FF	
	mSelectedDateBackground= 0xFFADD8E6
	mSelectedDateTextColor=0xFF000000
	mShowGridLines=True
	mWeekdayOrder=Array As Int(0,1,2,3,4,5,6)
	mWeekNames=GetWeekNames
	mMonthNames=GetMonthNames
	mBackgroundColor=0xFFFFFFFF
	mTextColor=0xFF000000
	mBorderColor=IIf(mEnabled=True,0xFFA9A9A9,Colors.LightGray)
	mBorderSize=1
	mBorderRadius=3
	mAlignment=19
	DateTime.DateFormat=mDateFormat
	mTextSize=12
	mText=DateTime.Date(DateTime.Now)	
	mYear=DateTime.GetYear(DateTime.Now)
	mMonth=DateTime.GetMonth(DateTime.Now)
	mDay=DateTime.GetDayOfMonth(DateTime.Now)	
	gmap.Initialize
	gmap1.Initialize
	mRc.Initialize
	Get_AlignMap	
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
	mBase.Tag = Me
	mLeft = mBase.Left
	mTop = mBase.Top
	mWidth = mBase.Width
	mHeight = mBase.Height
	Dim w As Int=mWidth
	z=w/100
	
	mDateFormat=Props.Get("DateFormat")
	mLanguage=Props.Get("Language")
	mFirstdayofWeek=Props.Get("FirstdayofWeek")
	mPickerPanelWidth=Props.Get("PickerPanelWidth")*z
	mPickerPanelHeight=Props.Get("PickerPanelHeight")*z
	mBodyBackground=Props.Get("BodyBackground")
	mBodyTextColor=Props.Get("BodyTextColor")
	mHeaderBackground=Props.Get("HeaderBackground")
	mHeaderTextColor=Props.Get("HeaderTextColor")
	mWeekTextBackground=Props.Get("WeekTextBackground")
	mWeekTextColor=Props.Get("WeekTextColor")	
	mSelectedDateBackground=Props.Get("SelectedDateBackground")
	mSelectedDateTextColor=Props.Get("SelectedDateTextColor")
	mShowGridLines=Props.Get("ShowGridLines")
	mAlignment=Lbl.Gravity
	mTextSize=Lbl.TextSize
	mTextColor=Lbl.TextColor
	mVisible=Lbl.Visible
	mEnabled=Lbl.Enabled
	mFont=Lbl.Typeface
	DateTime.DateFormat=mDateFormat
	mText=DateTime.Date(DateTime.Now)
	mBackgroundColor=mBase.Color
	mParent=mBase.Parent
	If GetType( mBase.As(Panel).Background) = "anywheresoftware.b4a.objects.drawable.ColorDrawable$GradientDrawableWithCorners" Then
		Dim cd As ColorDrawable = mBase.As(Panel).Background
		Dim jo As JavaObject = cd
		mBorderColor=IIf(mEnabled=True,jo.GetField("borderColor"),Colors.LightGray)
		myBorderColor=jo.GetField("borderColor")
		mBorderSize=jo.GetField("borderWidth")
		mBorderRadius=jo.GetField("cornerRadius")
	End If
	mWeekNames=GetWeekNames
	mMonthNames=GetMonthNames
	Sleep(0)	
	InitClass
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mWidth=Width
	mHeight=Height
	
	Panel1.Width=mWidth
	Panel1.Height=mHeight
	Dim size As Int=mHeight
	Panel3.Top=0
	Panel3.Height=size
	Panel3.Width=size
	Panel3.Left=mBase.Width-size
	Dim size1 As Int=mHeight*2/3
	ImageView1.Height=size1
	ImageView1.Width=size1
	ImageView1.Top=(mHeight-size1)/2
	ImageView1.Left=(size-size1)/2	
	Dim lwidth As Double=mBase.Width-Label1.Left-size
	Label1.Width=lwidth
	Label1.Height=mHeight
End Sub

Private Sub InitClass
	mBase.RemoveAllViews	
	mBase.LoadLayout("View")
	TouchPanel.RemoveView
	mParent.AddView(TouchPanel,0,0,mParent.Width,mParent.Height)
	mBase.As(Panel).Elevation=10dip
	Base_Resize(mWidth,mHeight)
	Label1.Typeface=mFont
	Label1.Text=mText
	Label1.TextColor=IIf(mEnabled=False,Colors.LightGray,mTextColor)
	Label1.TextSize=mTextSize
	Alignment=gmap.GetDefault(mAlignment,Array As String("CENTER","LEFT"))
	Label1.As(B4XView).SetTextAlignment(Alignment(0),Alignment(1))
	Panel1.Color=mBackgroundColor
	Panel1.As(B4XView).SetColorAndBorder(mBackgroundColor,mBorderSize,mBorderColor,mBorderRadius)
	cvsBase.Initialize(mBase)
	rectBase.Initialize(0, 0, mBase.Width, mBase.Height)
	DateView_Initialize	
End Sub

Private Sub DateView_Initialize
	Panel2.Width=mPickerPanelWidth
	Panel2.Height=mPickerPanelHeight
	Panel2.Elevation=mElevation
	HeaderPanel_Initialize	
	Table1.Width=Panel2.Width
	Table1.Top=HeaderPanel.Height
	Table1.Height=Panel2.Height*5/6	
	Table1.NumberOfColumns=7
	Table1.SetHeader(mWeekNames)
	Table1.HeaderHeight=Table1.Height/7
	Table1.TextSize=mTextSize-1
	Dim w1 As Int=Table1.Width/7
	Table1.SetColumnsWidths(Array As Int(w1,w1,w1,w1,w1,w1,w1))
	Table1.HeaderColor=mWeekTextBackground
	Table1.HeaderTextColor=mWeekTextColor
	Table1.RowColor1=mBodyBackground
	Table1.RowColor2=mBodyBackground
	Table1.SelectedRowColor=mBodyBackground
	Table1.SelectedCellColor=mSelectedDateBackground
	Table1.SelectedCellTextColor=mSelectedDateTextColor
	Table1.TextColor=mBodyTextColor
	Table1.RowHeight=Table1.Height/7
	Table1.LineWidth=IIf(mShowGridLines=True,1,0)	
	Table1.TableColor=IIf(mShowGridLines=True,0xFFE6E6FA,mBodyBackground)
	SetDateList(mYear,mMonth)	
End Sub

Private Sub HeaderPanel_Initialize
	HeaderPanel.Width=Panel2.Width
	HeaderPanel.Height=Panel2.Height/6
	HeaderPanel.Color=mHeaderBackground
	Panel4.Width=HeaderPanel.Width
	Panel4.Height=HeaderPanel.Height	
	lPanel.Width=Panel2.Width/2
	lPanel.Height=HeaderPanel.Height
	lPanel.Left=0
	rPanel.Width=Panel2.Width/2
	rPanel.Height=HeaderPanel.Height
	rPanel.Left=lPanel.Width	
	
	Dim size As Int=lPanel.Width/5
	Dim vsize As Int=size*3/4
	For Each p As Panel In Array As Panel(lImg1Panel,lImg2Panel,rImg1Panel,rImg2Panel)
		p.Color=Colors.Transparent
		p.Width=size
		p.Height=HeaderPanel.Height
		p.Top=0
		p.Left=IIf(p=lImg1Panel,0,IIf(p=lImg2Panel,size*3.5,IIf(p=rImg2Panel,rPanel.Width-size,rPanel.Width-size*4.5)))
		For Each v As ImageView In p
			v.Width=vsize
			v.Height=vsize
			v.Top=(p.Height-vsize)/2
			v.Left=IIf(p=lImg1Panel,size-vsize,IIf(p=lImg2Panel,0,IIf(p=rImg1Panel,size-vsize,0)))
		Next
	Next	
	MonthLabel.Width=lPanel.Width/2
	MonthLabel.Height=lPanel.Height
	MonthLabel.Left=size
	MonthLabel.Text=mMonthNames(mMonth-1)
	MonthLabel.TextColor=mHeaderTextColor
	MonthLabel.TextSize=mTextSize+1
	YearLabel.Width=rPanel.Width/2
	YearLabel.Height=rPanel.Height
	YearLabel.Left=rImg2Panel.Left-YearLabel.Width
	YearLabel.Text=mYear	
	YearLabel.TextColor=mHeaderTextColor
	YearLabel.TextSize=mTextSize+1	
		
	Get_Bmp(mEnabled)
End Sub

'自定义内部方法部分 ***********************************************************************************
'获取周名称数组
Private Sub GetWeekNames As Object
	Dim list As List=Array As String("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")
	Dim n As Int=list.IndexOf(mFirstdayofWeek)	
	Dim Erow(7) As String=Array As String("Sun","Mon","Tue","Wed","Thu","Fri","Sat")
	Dim Crow(7) As String=Array As String("日","一","二","三","四","五","六")
	Dim row(7) As String
	Dim row1(7) As String=IIf(mLanguage="English",Erow,Crow)
	For i=0 To 6
		Dim a As Int=IIf(i+n>6,i+n-7,i+n)		
		row(i)=row1(a)		
		mWeekdayOrder(i)=a		
	Next
	Return row
End Sub

'获取月份名称数组
Private Sub GetMonthNames As Object
	Dim Erow(12) As String=Array As String("Jan","Feb"," ‌Mar","‌Apr","May","Jun","Jul","‌Aug","Sep","Oct","Nov","Dec")
	Dim Crow(12) As String=Array As String("一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月")
	Dim row(12) As String=IIf(mLanguage="English",Erow,Crow)
	Return row
End Sub

'设置日期面板的日期列表
Private Sub SetDateList (year As Int,month As Int)
	Table1.ClearAll
	For i=1 To 6
		Table1.AddRow(Array As String("","","","","","",""))
	Next	
	Dim d1 As Long=DateUtils.SetDate(year,month,1)
	Dim n As Int=DateTime.GetDayOfWeek(d1)-1
	Dim list As List=mWeekdayOrder
	Dim index As Int=list.IndexOf(n)
	
	Dim co As Int=DateUtils.NumberOfDaysInMonth(month,year)
	Dim col=index,row=0 As Int	
	For i=1 To co		
		If col<7 Then
			Table1.SetValue(col,row,i)
			If i=mDay Then
				mRc.Col=col
				mRc.Row=row	
			End If
			col=col+1
			If col=7 Then
				col=0
				row=row+1
			End If
		End If		
	Next
	Dim d As Long=DateTime.DateParse(Label1.Text)
	If DateTime.GetYear(d)=YearLabel.Text And MonthLabel.Text=mMonthNames( DateTime.GetMonth(d)-1) Then
		Table1.SelectRow(mRc)
	End If
End Sub

'获取Gravity值映射地图
'gmap----key:Gravity值;value:row(Vertical,Horizontal))
'gmap1---key:row(Vertical,Horizontal);value:Gravity值
Private Sub Get_AlignMap
	Dim vmap As Map
	vmap.Initialize
	Dim value(3) As Int=Array As Int(16,48,80)
	Dim i As Int=0
	For Each t As String In Array As String("CENTER","TOP","BOTTOM")
		vmap.Put(t,value(i))
		i=i+1
	Next
	Dim hmap As Map
	hmap.Initialize
	value=Array As Int(1,3,5)
	i=0
	For Each t As String In Array As String("CENTER","LEFT","RIGHT")
		hmap.Put(t,value(i))
		i=i+1
	Next
	
	For i=0 To vmap.Size-1
		For j=0 To hmap.Size-1
			Dim row(2) As String
			row(0)=vmap.GetKeyAt(i)
			row(1)=hmap.GetKeyAt(j)
			Dim v As Int=vmap.GetValueAt(i)+hmap.GetValueAt(j)
			gmap.Put(v,row)
			gmap1.Put(row,v)
		Next
	Next
End Sub

'设置Imageview的bmp图像
Private Sub Get_Bmp (Enable As Boolean)
	Dim imgName As String=IIf(Enable=True,"date.png","disabledate.png")
	Dim bmp As B4XBitmap=xui.LoadBitmapResize(File.DirAssets,imgName,ImageView1.Width,ImageView1.Height,True)
	ImageView1.Bitmap=bmp
	imgName="back.png"
	bmp=xui.LoadBitmapResize(File.DirAssets,imgName,lImg1.Width,lImg1.Height,True)
	lImg1.Bitmap=bmp
	rImg1.Bitmap=bmp
	imgName="go.png"
	bmp=xui.LoadBitmapResize(File.DirAssets,imgName,lImg2.Width,lImg2.Height,True)
	lImg2.Bitmap=bmp
	rImg2.Bitmap=bmp
End Sub

'重置主面板可用属性
Private Sub Reset_MbaseEnabled
	Dim nTextColor As Int=mTextColor
	mBorderColor=IIf(mEnabled=False,Colors.LightGray,myBorderColor)
	If mEnabled=False Then
		nTextColor=Colors.LightGray
		If Panel2.Visible=True Then
			Panel2.Visible=False
		End If
	End If
	Get_Bmp(mEnabled)
	Panel1.As(B4XView).SetColorAndBorder(mBackgroundColor,mBorderSize,mBorderColor,mBorderRadius)
	Label1.TextColor=nTextColor
End Sub

Private Sub Check_DateString(year As String,month As String,day As String) As Boolean
	Dim b1 As Boolean=False
	If IsNumber(year) And IsNumber(month) And IsNumber(day) Then
		Dim Maxday As Int=DateUtils.NumberOfDaysInMonth(month,year)
		If month.As(Int)>0 And month.As(Int)<13 And day.As(Int)>0 And day.As(Int)<=Maxday Then
			b1=True
		End If
	End If
	Return b1
End Sub

'内部事件部分 ****************************************************************************************

Private Sub ImageView1_Click
	If mEnabled=True Then
		If Panel2.Visible=False Then
			If Panel2.Parent<>mBase.Parent Then
				Panel2.RemoveView
				mBase.Parent.AddView(Panel2,mLeft,mTop+mHeight,Panel2.Width,Panel2.Height)				
			End If			
			Panel2.Visible=True						
			Dim x As Int=100%x
			Dim y As Int=100%y
			Panel2.Top=IIf(mPickerPanelHeight>y-mTop-mHeight,mTop-mPickerPanelHeight,mTop+mHeight)
			Panel2.Left=IIf(mPickerPanelWidth>x-mLeft,mLeft+mWidth-mPickerPanelWidth,mLeft)			
		Else
			Panel2.Visible=False
		End If
	End If
End Sub

Private Sub Panel1_Touch (Action As Int, X As Float, Y As Float)
	If mEnabled=True Then
		Select Action
			Case Panel1.ACTION_DOWN
				Panel1.SetColorAnimated(300,0xFFE6E6FA,0xFFB0C4DE)
			Case Panel1.ACTION_UP
				Panel1.SetColorAnimated(300,0xFFB0C4DE,mBackgroundColor)
				ImageView1_Click
		End Select
	End If
End Sub

Private Sub Table1_CellClick(col As Int, row As Int)
	mYear=YearLabel.Text
	Dim list As List=mMonthNames
	mMonth=list.IndexOf(MonthLabel.Text)+1
	mRc.Col=col
	mRc.Row=row
	mDay=Table1.GetValue(col,row)
	Dim d As Long=DateUtils.SetDate(mYear,mMonth,mDay)
	mText=DateTime.Date(d)
	Label1.Text=mText
	Panel2.Visible=False
	If xui.SubExists(mCallBack, mEventName & "_ValueChanged", 1) Then
		CallSubDelayed2(mCallBack, mEventName & "_ValueChanged",mText)
	End If
End Sub

Private Sub TouchPanel_Touch (Action As Int, X As Float, Y As Float)
	If Panel2.Visible=True Then
		If (X<Panel2.Left Or X>Panel2.Left+Panel2.Width) Or (Y<Panel2.Top Or Y>Panel2.Top+Panel2.Height) Then
			Panel2.Visible=False
		End If
	End If
End Sub

Private Sub Panel4_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case HeaderPanel.ACTION_DOWN
			If X>=0 And X<=lImg1Panel.Width+10dip Then
				lImg1Panel.SetColorAnimated(50,0xFFE6E6FA,0xFFB0C4DE)
			End If
			If X>=lPanel.Width-lImg2Panel.Width-10dip And X<=lPanel.Width Then
				lImg2Panel.SetColorAnimated(50,0xFFE6E6FA,0xFFB0C4DE)
			End If
			If X>=lPanel.Width And X<=lPanel.Width+rImg1Panel.Width+10dip Then
				rImg1Panel.SetColorAnimated(50,0xFFE6E6FA,0xFFB0C4DE)
			End If
			If X>=HeaderPanel.Width-rImg2Panel.Width-10dip And X<=HeaderPanel.Width Then
				rImg2Panel.SetColorAnimated(50,0xFFE6E6FA,0xFFB0C4DE)
			End If
		Case HeaderPanel.ACTION_UP
			If X>=0 And X<=lImg1Panel.Width+10dip Then
				lImg1Panel.SetColorAnimated(200,0xFFB0C4DE,Colors.Transparent)
				Dim a As Int=mMonth
				If a>1 Then
					mMonth=a-1
				Else
					mMonth=12
					mYear=mYear-1
					YearLabel.Text=mYear
				End If
				MonthLabel.Text=mMonthNames(mMonth-1)
				SetDateList(mYear,mMonth)
			End If
			If X>=lPanel.Width-lImg2Panel.Width-10dip And X<=lPanel.Width Then
				lImg2Panel.SetColorAnimated(200,0xFFB0C4DE,Colors.Transparent)
				Dim a As Int=mMonth
				If a<12 Then
					mMonth=a+1
				Else
					mMonth=1
					mYear=mYear+1
					YearLabel.Text=mYear
				End If
				MonthLabel.Text=mMonthNames(mMonth-1)
				SetDateList(mYear,mMonth)
			End If
			If X>=lPanel.Width And X<=lPanel.Width+rImg1Panel.Width+10dip Then
				rImg1Panel.SetColorAnimated(200,0xFFB0C4DE,Colors.Transparent)
				mYear=mYear-1
				YearLabel.Text=mYear
				SetDateList(mYear,mMonth)
			End If
			If X>=HeaderPanel.Width-rImg2Panel.Width-10dip And X<=HeaderPanel.Width Then
				rImg2Panel.SetColorAnimated(200,0xFFB0C4DE,Colors.Transparent)
				mYear=mYear+1
				YearLabel.Text=mYear
				SetDateList(mYear,mMonth)
			End If
	End Select
End Sub

'属性部分 ********************************************************************************************

Public Sub getBackground As Int
	Return mBackgroundColor
End Sub

Public Sub setBackground (color As Int)
	mBackgroundColor=color
	mBase.Color=color
	Panel1.Color=color
End Sub

Public Sub getWidth As Int
	Return mWidth
End Sub

Public Sub setWidth (width As Int)
	mWidth=width
	mBase.Width=width
	Base_Resize(mWidth,mHeight)
End Sub

Public Sub getHeight As Int
	Return mHeight
End Sub

Public Sub setHeight (height As Int)
	mHeight=height
	mBase.Height=height
	Base_Resize(mWidth,mHeight)
End Sub

Public Sub getLeft As Int
	Return mLeft
End Sub

Public Sub setLeft (left As Int)
	mLeft=left
	mBase.Left=mLeft
End Sub

Public Sub getTop As Int
	Return mTop
End Sub

Public Sub setTop (top As Int)
	mTop=top
	mBase.Top=mTop
End Sub

Public Sub getParent As B4XView
	Return mParent
End Sub

Public Sub getText As String
	Return mText
End Sub

Public Sub setText(text As String)
	If IsDate(text)=False Then
		xui.MsgboxAsync("日期字符串格式不正确！","提示信息")
		Return
	End If
	mText=text
	Label1.Text=mText
	Dim d As Long=DateTime.DateParse(mText)
	mYear=DateTime.GetYear(d)
	mMonth=DateTime.GetMonth(d)
	mDay=DateTime.GetDayOfMonth(d)
	YearLabel.Text=mYear
	MonthLabel.Text=mMonthNames(mMonth-1)
	SetDateList(mYear,mMonth)
	If xui.SubExists(mCallBack, mEventName & "_ValueChanged", 1) Then
		CallSubDelayed2(mCallBack, mEventName & "_ValueChanged",mText)
	End If
End Sub

Public Sub getTextColor As Int
	Return mTextColor
End Sub

Public Sub setTextColor(TextColor As Int)
	mTextColor=TextColor
	Label1.TextColor=mTextColor
End Sub

Public Sub getTextSize As Int
	Return mTextSize
End Sub

Public Sub setTextSize(TextSize As Int)
	mTextSize=TextSize
	Label1.TextSize = mTextSize
	DateView_Initialize
End Sub

Public Sub getVerticalTextAlign As String
	Return Alignment(0)
End Sub

Public Sub setVerticalTextAlign(Vertical As String)
	Dim a As String=Vertical.ToUpperCase
	Dim list As List
	list.Initialize2(Array As String("TOP","CENTER","BOTTOM"))
	If list.IndexOf(a)>=0 Then
		Alignment(0)=a
		mAlignment=gmap1.GetDefault(Alignment,19)
		Label1.As(B4XView).SetTextAlignment(Alignment(0),Alignment(1))
	End If
End Sub

Public Sub getHorizontalTextAlign As String
	Return Alignment(1)
End Sub

Public Sub setHorizontalTextAlign(Horizontal As String)
	Dim a As String=Horizontal.ToUpperCase
	Dim list As List
	list.Initialize2(Array As String("LEFT","CENTER","RIGHT"))
	If list.IndexOf(a)>=0 Then
		Alignment(1)=a
		mAlignment=gmap1.GetDefault(Alignment,19)
		Label1.As(B4XView).SetTextAlignment(Alignment(0),Alignment(1))
	End If
End Sub

Public Sub getFont As Typeface
	Return mFont
End Sub

Public Sub setFont(font As Typeface)
	mFont=font
	Label1.Typeface=mFont
End Sub

Public Sub getBorderColor As Int
	Return mBorderColor
End Sub

Public Sub setBorderColor(BorderColor As Int)
	mBorderColor=BorderColor
	myBorderColor=BorderColor
	Panel1.As(B4XView).SetColorAndBorder(mBackgroundColor,mBorderSize,mBorderColor,mBorderRadius)
End Sub

Public Sub getBorderSize As Int
	Return mBorderSize
End Sub

Public Sub setBorderSize(BorderSize As Int)
	mBorderSize=BorderSize
	Panel1.Padding=Array As Int(BorderSize,BorderSize,BorderSize,BorderSize)
	Panel1.As(B4XView).SetColorAndBorder(mBackgroundColor,mBorderSize,mBorderColor,mBorderRadius)
End Sub

Public Sub getBorderRadius As Int
	Return mBorderRadius
End Sub

Public Sub setBorderRadius(BorderRadius As Int)
	mBorderRadius=BorderRadius
	Panel1.As(B4XView).SetColorAndBorder(mBackgroundColor,mBorderSize,mBorderColor,mBorderRadius)
	InitClass
End Sub

Public Sub getDateFormat As String
	Return mDateFormat
End Sub

Public Sub setDateFormat(DateFormat As String)
	Dim list As List
	list.Initialize2(Array As String("yyyy年MM月dd日","yyyy-MM-dd","yyyy.MM.dd","yyyy/MM/dd","MM/dd/yyyy","MM-dd-yyyy"))
	If list.IndexOf(DateFormat)>=0 Then
		mDateFormat=DateFormat
		Dim d As Long=DateTime.DateParse(mText)
		DateTime.DateFormat=mDateFormat
		mText=DateTime.Date(d)
		Label1.Text=mText
	End If
End Sub

Public Sub getLanguage As String
	Return mLanguage
End Sub

Public Sub setLanguage(Language As String)
	Dim a As String=""
	If Language.ToUpperCase="ENGLISH" Then a="English"
	If Language.ToUpperCase="CHINESE" Then a="Chinese"
	Dim list As List
	list.Initialize2(Array As String("English","Chinese"))
	If list.IndexOf(a)>=0 Then
		mLanguage=a
		mWeekNames=GetWeekNames
		mMonthNames=GetMonthNames
		DateView_Initialize
	End If
End Sub

Public Sub getVisible As Boolean
	Return mVisible
End Sub

Public Sub setVisible (visible As Boolean)
	mVisible=visible
	mBase.Visible=mVisible
	If mBase.Visible=False Then
		Panel2.Visible=False
	End If
End Sub

Public Sub getEnabled As Boolean
	Return mEnabled
End Sub

Public Sub setEnabled (Enable As Boolean)
	mEnabled=Enable
	Reset_MbaseEnabled
End Sub

Public Sub getFirstdayofWeek As String
	Return mFirstdayofWeek
End Sub

Public Sub setFirstdayofWeek (FirstdayofWeek As String)
	Dim list As List=Array As String("sunday","monday","tuesday","wednesday","thursday","friday","saturday")
	If list.IndexOf(FirstdayofWeek.ToLowerCase)>=0 Then
		Dim a,b As String=""
		For i=0 To FirstdayofWeek.Length-1
			b=FirstdayofWeek.SubString2(i,i+1)
			b=IIf(i=0,b.ToUpperCase,b.ToLowerCase)
			a=a&b
		Next
		mFirstdayofWeek=a
		mWeekNames=GetWeekNames
		Table1.SetHeader(mWeekNames)
		SetDateList(mYear,mMonth)
	End If
End Sub

Public Sub getFirstdayIndexofWeek As Int
	Dim list As List=Array As String("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")
	Return list.IndexOf(mFirstdayofWeek)
End Sub

Public Sub setFirstdayIndexofWeek (FirstdayIndexofWeek As Int)
	Dim list As List=Array As String("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")
	If FirstdayIndexofWeek>=0 And FirstdayIndexofWeek<7 Then
		mFirstdayofWeek=list.Get(FirstdayIndexofWeek)
		mWeekNames=GetWeekNames
		Table1.SetHeader(mWeekNames)
		SetDateList(mYear,mMonth)
	End If
End Sub

Public Sub getPickerPanelWidth As Int
	Return mPickerPanelWidth
End Sub

Public Sub setPickerPanelWidth (PickerPanelWidth As Int)
	mPickerPanelWidth=PickerPanelWidth
	DateView_Initialize
End Sub

Public Sub getPickerPanelHeight As Int
	Return mPickerPanelHeight
End Sub

Public Sub setPickerPanelHeight (PickerPanelHeight As Int)
	mPickerPanelHeight=PickerPanelHeight
	DateView_Initialize
End Sub

Public Sub getPickerPanelElevation As Int
	Return mElevation
End Sub

Public Sub setPickerPanelElevation (PickerPanelElevation As Int)
	mElevation=PickerPanelElevation
	Panel2.Elevation=mElevation
End Sub

Public Sub getBodyBackground As Int
	Return mBodyBackground
End Sub

Public Sub setBodyBackground (BodyBackground As Int)
	mBodyBackground=BodyBackground
	DateView_Initialize
End Sub

Public Sub getBodyTextColor As Int
	Return mBodyTextColor
End Sub

Public Sub setBodyTextColor (BodyTextColor As Int)
	mBodyTextColor=BodyTextColor
	Table1.TextColor=mBodyTextColor
End Sub

Public Sub getHeaderBackground As Int
	Return mHeaderBackground
End Sub

Public Sub setHeaderBackground (HeaderBackground As Int)
	mHeaderBackground=HeaderBackground
	HeaderPanel_Initialize
End Sub

Public Sub getHeaderTextColor As Int
	Return mHeaderTextColor
End Sub

Public Sub setHeaderTextColor (HeaderTextColor As Int)
	mHeaderTextColor=HeaderTextColor
	HeaderPanel_Initialize
End Sub

Public Sub getWeekTextBackground As Int
	Return mWeekTextBackground
End Sub

Public Sub setWeekTextBackground (WeekTextBackground As Int)
	mWeekTextBackground=WeekTextBackground
	Table1.HeaderColor=mWeekTextBackground
End Sub

Public Sub getWeekTextColor As Int
	Return mWeekTextColor
End Sub

Public Sub setWeekTextColor (WeekTextColor As Int)
	mWeekTextColor=WeekTextColor
	Table1.HeaderTextColor=mWeekTextColor
End Sub

Public Sub getSelectedDateBackground As Int
	Return mSelectedDateBackground
End Sub

Public Sub setSelectedDateBackground (SelectedDateBackground As Int)
	mSelectedDateBackground=SelectedDateBackground
	Table1.SelectedCellColor=mSelectedDateBackground
	SetDateList(mYear,mMonth)
End Sub

Public Sub getSelectedDateTextColor As Int
	Return mSelectedDateTextColor
End Sub

Public Sub setSelectedDateTextColor (SelectedDateTextColor As Int)
	mSelectedDateTextColor=SelectedDateTextColor
	Table1.SelectedCellTextColor=mSelectedDateTextColor
	SetDateList(mYear,mMonth)
End Sub

Public Sub getShowGridLines As Boolean
	Return mShowGridLines
End Sub

Public Sub setShowGridLines (ShowGridLines As Boolean)
	mShowGridLines=ShowGridLines
	Table1.LineWidth=IIf(mShowGridLines=True,1,0)
	Table1.TableColor=IIf(mShowGridLines=True,0xFFE6E6FA,mBodyBackground)
End Sub

'方法部分 ********************************************************************************************

Public Sub AddToParent(Parent As B4XView, Left As Int, Top As Int, Width As Int, Height As Int)
	mBase.RemoveAllViews
	mLeft=Left
	mTop=Top
	mWidth=Width
	mHeight=Height
	mParent = Parent
	mBase.RemoveViewFromParent
	Parent.AddView(mBase, mLeft, mTop, mWidth, mHeight)
	mBase.Tag = Me
	InitClass
End Sub

Public Sub IsDate(text As String) As Boolean
	Dim b As Boolean=False
	Dim year,month,day As String
	Select mDateFormat
		Case "yyyy年MM月dd日"
			year=text.SubString2(0,4)
			month=text.SubString2(5,7)
			day=text.SubString2(8,10)
			If text.Length=11 And text.IndexOf("年")=4 And text.IndexOf("月")=7 And text.IndexOf("日")=10 Then
				b=Check_DateString(year,month,day)
			End If
		Case "yyyy-MM-dd"
			year=text.SubString2(0,4)
			month=text.SubString2(5,7)
			day=text.SubString2(8,10)
			If text.Length=10 And text.SubString2(4,5)="-" And text.SubString2(7,8)="-" Then
				b=Check_DateString(year,month,day)
			End If
		Case "yyyy.MM.dd"
			year=text.SubString2(0,4)
			month=text.SubString2(5,7)
			day=text.SubString2(8,10)
			If text.Length=10 And text.SubString2(4,5)="." And text.SubString2(7,8)="." Then
				b=Check_DateString(year,month,day)
			End If
		Case "MM-dd-yyyy"
			year=text.SubString2(6,10)
			month=text.SubString2(0,2)
			day=text.SubString2(3,5)
			If text.Length=10 And text.SubString2(2,3)="-" And text.SubString2(5,6)="-" Then
				b=Check_DateString(year,month,day)
			End If
		Case "yyyy/MM/dd"
			year=text.SubString2(0,4)
			month=text.SubString2(5,7)
			day=text.SubString2(8,10)
			If text.Length=10 And text.SubString2(4,5)="/" And text.SubString2(7,8)="/" Then
				b=Check_DateString(year,month,day)
			End If
		Case "MM/dd/yyyy"
			year=text.SubString2(6,10)
			month=text.SubString2(0,2)
			day=text.SubString2(3,5)
			If text.Length=10 And text.SubString2(2,3)="/" And text.SubString2(5,6)="/" Then
				b=Check_DateString(year,month,day)
			End If
	End Select
	Return b
End Sub
